"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfig = void 0;
const webpack = __importStar(require("webpack"));
const webpack_node_externals_1 = __importDefault(require("webpack-node-externals"));
const getConfig = function getConfig(base, option) {
    const isDev = option.mode === 'development';
    const entry = typeof option.entry === 'string' ? { app: option.entry } : { ...option.entry };
    const config = {
        ...base,
        entry,
        mode: option.mode,
        devtool: 'source-map',
        target: 'node',
        externals: [webpack_node_externals_1.default()],
        output: {
            filename: isDev ? '[name].js' : '[name]/app.js',
            libraryTarget: 'commonjs2',
            path: option.dist,
            publicPath: option.publicPath,
        },
        optimization: {
            minimize: false,
        },
    };
    config.module.rules.push({
        test: /\.tsx?$/,
        loader: 'ts-loader',
        options: {
            appendTsSuffixTo: [/\.vue$/],
            transpileOnly: true,
            compilerOptions: {
                target: 'es2018',
                esModuleInterop: true,
            },
        },
    }, {
        test: /\.jsx?$/,
        loader: 'babel-loader',
        options: {
            cwd: __dirname,
            presets: [
                ['@babel/preset-env', { targets: { node: '10' } }],
            ],
            plugins: [
                ['@babel/plugin-proposal-decorators', { legacy: true }],
                ['@babel/plugin-proposal-class-properties'],
            ],
        },
    }, {
        test: /\.css$/,
        use: ['null-loader'],
    }, {
        test: /\.less$/,
        use: ['null-loader'],
    });
    config.plugins.push(new webpack.DefinePlugin({
        'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV || option.mode),
        'process.env.VUE_ENV': JSON.stringify('server'),
    }));
    if (isDev) {
        config.plugins.push(new webpack.ProgressPlugin(option.onProgress));
    }
    return config;
};
exports.getConfig = getConfig;
