"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hot = void 0;
const stream_1 = require("stream");
const webpack_hot_middleware_1 = __importDefault(require("webpack-hot-middleware"));
/* eslint-disable no-param-reassign */
function hot(compiler, opts) {
    const middleware = webpack_hot_middleware_1.default(compiler, {
        path: '/__webpack_hmr',
        ...opts,
    });
    return async (ctx, next) => {
        if (ctx.request.path !== opts.path) {
            return await next();
        }
        const stream = new stream_1.PassThrough();
        ctx.body = stream;
        middleware(ctx.req, {
            write: stream.write.bind(stream),
            writeHead: (status, headers) => {
                ctx.status = status;
                Object.keys(headers).forEach((key) => {
                    ctx.set(key, headers[key]);
                });
            },
            end: () => stream.end(),
        }, next);
    };
}
exports.hot = hot;
