"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.copy = void 0;
const stream_cp_1 = __importDefault(require("stream-cp"));
const fs_1 = require("fs");
const copy = async function copy(patterns) {
    const copyTasks = patterns.map(({ from, to }) => new Promise((resolve, reject) => {
        const isFile = fs_1.statSync(from).isFile();
        // 如果是文件，直接复制到目标目录
        if (isFile) {
            fs_1.createReadStream(from)
                .pipe(fs_1.createWriteStream(to))
                .on('finish', () => resolve(true))
                .on('error', reject);
        }
        else {
            stream_cp_1.default(from, to, file => file, (err) => {
                err ? reject(err) : resolve(true);
            });
        }
    }));
    return Promise.all(copyTasks);
};
exports.copy = copy;
