"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.merge = void 0;
const webpack_merge_1 = require("webpack-merge");
/* eslint-disable no-param-reassign */
function merge(source, custom) {
    if (!custom) {
        return source;
    }
    const { externals } = custom;
    custom.externals = undefined;
    const newConfig = webpack_merge_1.merge(source, custom);
    if (externals) {
        const externalList = Array.isArray(externals) ? externals : [externals];
        Array.isArray(newConfig.externals)
            ? newConfig.externals.unshift(...externalList)
            : (newConfig.externals = [...externalList, newConfig.externals].filter(Boolean));
    }
    custom.externals = externals;
    return newConfig;
}
exports.merge = merge;
